程序師世界是廣大編程愛好者互助、分享、學習的平台,程序師世界有你更精彩!
首頁
編程語言
C語言|JAVA編程
Python編程
網頁編程
ASP編程|PHP編程
JSP編程
數據庫知識
MYSQL數據庫|SqlServer數據庫
Oracle數據庫|DB2數據庫
 程式師世界 >> 編程語言 >> C語言 >> C++ >> C++入門知識 >> Codeforces Round #369 (Div. 2)---C,

Codeforces Round #369 (Div. 2)---C,

編輯:C++入門知識

Codeforces Round #369 (Div. 2)---C,


題目鏈接

http://codeforces.com/contest/711/problem/C

 

Description

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, nm and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color jpi, j's are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

 

Examples input
3 2 2
0 0 0
1 2
3 4
5 6
output
10
input
3 2 2
2 1 2
1 3
2 4
3 5
output
-1
input
3 2 2
2 0 0
1 3
2 4
3 5
output
5
input
3 2 3
2 1 2
1 3
2 4
3 5
output
0
Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

 

題意:有n棵樹,m種顏料,要求現在要給這些樹塗上顏料,最後塗成k段(連續顏色相同劃為一段如2, 1, 1, 1, 3, 2, 2, 3, 1, 3是7段),有些樹已經塗了,則不塗了只能塗一次,輸入n個數(每個數為0~m),0表示還沒有塗,1~m表示已經塗了哪種顏料。接下來輸入n行m列,表示每棵樹塗成每種顏色所要的顏料量。現在要把所有樹都塗上顏料塗成k段,求最少要用的顏料量;

思路:DP題,看到數據范圍100,只能用3重循環解決問題(據說這題4重循環也能過~) dp[i][j][k] 表示從第一棵樹開始塗,塗到第i棵樹,有j段,且第i棵樹塗的k種顏料所需要的最少顏料量,那麼有狀態轉移方程dp[i][j][k]=min(my,dp[i-1][j][k])+cost[i][k]; my其實就是my=min( dp[i-1][j-1][非k] );  最後min( dp[n][k][i]  1<=i<=m ) 就是答案;

代碼如下:

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>
#include <cmath>
#define eps 1e-8
#define maxn 105
#define inf 0x3f3f3f3f3f3f3f3f
#define IN freopen("in.txt","r",stdin);
using namespace std;
int c[105];
long long cost[105][105];
long long dp[105][105][105];
pair<long long,int> mfirst[105][105],msecond[105][105];

int main()
{
    int n,m,s;
    while(scanf("%d%d%d",&n,&m,&s)!=EOF)
    {
        for(int i=1;i<=n;i++)
            scanf("%d",&c[i]);
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
                scanf("%I64d",&cost[i][j]);
            if(c[i])  cost[i][c[i]]=0;
        }

        memset(dp,inf,sizeof(dp));
        memset(mfirst,inf,sizeof(mfirst));
        memset(msecond,inf,sizeof(msecond));
        for(int i=1;i<=m;i++)
            dp[0][0][i]=0;
        mfirst[0][0]=make_pair(0,-1);
        msecond[0][0]=make_pair(0,-1);
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=s&&j<=i;j++)
            {
                for(int k=1;k<=m;k++)
                {
                    if(c[i]&&c[i]!=k) continue;
                    long long my=mfirst[i-1][j-1].first;
                    if(mfirst[i-1][j-1].second==k) my=msecond[i-1][j-1].first;
                    
                    dp[i][j][k]=min(my,dp[i-1][j][k])+cost[i][k];
                    if(dp[i][j][k]<mfirst[i][j].first){
                        msecond[i][j].first=mfirst[i][j].first;
                        mfirst[i][j].first=dp[i][j][k];
                        msecond[i][j].second=mfirst[i][j].second;
                        mfirst[i][j].second=k;
                    }
                    else if(dp[i][j][k]<msecond[i][j].first){
                        msecond[i][j].first=dp[i][j][k];
                        msecond[i][j].second=k;
                    }
                }
            }
        }
        long long ans=inf;
        for(int i=1;i<=m;i++)
            ans=min(ans,dp[n][s][i]);
        if(ans==inf)
            puts("-1");
        else
        printf("%I64d\n",ans);
    }
    return 0;
}

 

 

  1. 上一頁:
  2. 下一頁:
Copyright © 程式師世界 All Rights Reserved